package hr.fer.grading;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Spliterator;
import java.util.Spliterators;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

public class NetworkInterfaceWrapper {

  private NetworkInterface ni;

  public NetworkInterfaceWrapper(NetworkInterface ni) {
    this.ni = ni;
  }

  public String getName() {
    return ni.getName();
  }

  public String getDisplayName() {
    return ni.getDisplayName();
  }

  public Stream<InetAddress> getInetAddresses() {
    Iterator<InetAddress> iterator = ni.getInetAddresses().asIterator();
    Spliterator<InetAddress> spliterator = Spliterators.spliteratorUnknownSize(iterator, Spliterator.ORDERED);
    return StreamSupport.stream(spliterator, false);
  }

  public List<Integer> getMacAddress() throws SocketException {
    byte[] mac = ni.getHardwareAddress();
    if(mac == null)
      return null;

    List<Integer> list = new LinkedList<>();
    for(byte b: mac)
      list.add(Byte.toUnsignedInt(b));
    return list;
  }

  public boolean isUp() throws SocketException {
    return ni.isUp();
  }

  public boolean isVirtual() {
    return ni.isVirtual();
  }

}
